local Interrupt_EventFrame = CreateFrame("frame")
Interrupt_EventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

local pciscript = CreateFrame("Frame")
pciscript:RegisterEvent("PLAYER_ENTERING_WORLD")
pciscript:RegisterEvent("ADDON_LOADED")
pciscript:RegisterEvent("PLAYER_LOGIN")
pciscript:RegisterEvent("PLAYER_LOGOUT")

local inInstance, instanceType = IsInInstance()

Interrupt_EventFrame:SetScript("OnEvent", function(self, event, ...)
        self[event](self, ...)
end)

function Interrupt_EventFrame:COMBAT_LOG_EVENT_UNFILTERED()
    local _, eventType, _, sourceGUID, sourceName, _, _, destGUID, destName, _, _, sourceID, _, _, spellID, spellName, spellSchool = CombatLogGetCurrentEventInfo()
    -- Player interrupt
	if (TyllusInterrupt == 1 or TyllusInterrupt == nil) and eventType ==  "SPELL_INTERRUPT" and (IsInInstance(true,"party") or IsInInstance(true,"raid") or IsInInstance(true,"arena"))
	and (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) and not UnitIsFriend("player", destName) == true then
        if (TyllusInterruptSpellName == 1 or TyllusInterruptSpellName == nil) then SendChatMessage(sourceName.." interrupted " .. GetSpellLink(spellID))
		else SendChatMessage(sourceName.." interrupted")
		end
    elseif eventType == "SPELL_INTERRUPT" and (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) and not UnitIsFriend("player", destName) == true then
		local localizedClass, englishClass, classIndex = UnitClass(sourceName);
		if localizedClass == nil then print("|cf000ff96<TyllusInterrupt>|r |cf0ffffffYOU|r" .. " interrupted " .. GetSpellLink(spellID))
		else
		if classIndex == 1 then local ClassColor = "C79C6E" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Warrior
			elseif classIndex == 2 then local ClassColor = "F58CBA" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Paladin
			elseif classIndex == 3 then local ClassColor = "A9D271" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Hunter
			elseif classIndex == 4 then local ClassColor = "FFF569" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Rogue
			elseif classIndex == 5 then local ClassColor = "FFFFFF" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Priest
			elseif classIndex == 6 then local ClassColor = "C41F3B" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Death Knight
			elseif classIndex == 7 then local ClassColor = "0070DE" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Shaman
			elseif classIndex == 8 then local ClassColor = "40C7EB" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Mage
			elseif classIndex == 9 then local ClassColor = "8787ED" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Warlock
			elseif classIndex == 10 then local ClassColor = "00FF96" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Monk
			elseif classIndex == 11 then local ClassColor = "FF7D0A" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Druid
			elseif classIndex == 12 then local ClassColor = "A330C9" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID)) -- Demon Hunter
			else local ClassColor = "FFFFFF" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. "YOU|r" .. " interrupted " .. GetSpellLink(spellID))        
			end
		end
	end
	-- Others interrupt
	if (TyllusInterruptOthers == 1 or TyllusInterruptOthers == nil) and eventType ==  "SPELL_INTERRUPT" and (IsInInstance(true,"party") or IsInInstance(true,"raid") or IsInInstance(true,"arena"))
		and not (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) and UnitIsFriend("player", sourceName) == true and not UnitIsFriend("player", destName) == true then
	local localizedClass, englishClass, classIndex = UnitClass(sourceName);
		if localizedClass == nil then print("|cf000ff96<TyllusInterrupt>|r " .. sourceName .. " interrupted " .. GetSpellLink(spellID))
		else
		--Class color
		if classIndex == 1 then local ClassColor = "C79C6E" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Warrior
			elseif classIndex == 2 then local ClassColor = "F58CBA" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Paladin
			elseif classIndex == 3 then local ClassColor = "A9D271" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Hunter
			elseif classIndex == 4 then local ClassColor = "FFF569" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Rogue
			elseif classIndex == 5 then local ClassColor = "FFFFFF" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Priest
			elseif classIndex == 6 then local ClassColor = "C41F3B" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Death Knight
			elseif classIndex == 7 then local ClassColor = "0070DE" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Shaman
			elseif classIndex == 8 then local ClassColor = "40C7EB" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Mage
			elseif classIndex == 9 then local ClassColor = "8787ED" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Warlock
			elseif classIndex == 10 then local ClassColor = "00FF96" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Monk
			elseif classIndex == 11 then local ClassColor = "FF7D0A" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Druid
			elseif classIndex == 12 then local ClassColor = "A330C9" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID)) -- Demon Hunter
			else local ClassColor = "FFFFFF" print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. ClassColor .. sourceName .. "|r" .. " interrupted " .. GetSpellLink(spellID))
		end
		end
	end
end
----------
--Slash commands
----------
SLASH_TINT1 = "/tint";
local function handler(msg, editbox)
	if msg == 'say' then -- say
		if TyllusInterrupt == 0 then TyllusInterrupt = 1
		print ('|cf000ff96<TyllusInterrupt>|r: Announcing interrupts to SAY channel has been turned |cf00cc00fON|r');
		else TyllusInterrupt = 0
		    print ('|cf000ff96<TyllusInterrupt>|r: Announcing interrupts to SAY channel has been turned |cfcc3300fOFF|r');
		end
    elseif msg == 'setup' then -- Setup
		print ("|cf000ff96<TyllusInterrupt>|r |cf0ffff00Setup:|r");
    	if TyllusInterrupt == 0 then -- SAY turned on?
		local IsSayOn = "|cfcc3300fOFF|r" print ("Interrupt announce to SAY is " .. IsSayOn);
		else local IsSayOn = "|cf00cc00fON|r" print ("Interrupt announce to SAY is " .. IsSayOn);
      	end
      	if TyllusInterruptSpellName == 0 then -- Spell Name turned on?
		local SpellNameOn = "|cfcc3300fOFF|r"; print ("Announcing name of the interrupted spell is " .. SpellNameOn);
    	else local SpellNameOn = "|cf00cc00fON|r"; print ("Announcing name of the interrupted spell is " .. SpellNameOn);
      	end
		if TyllusInterruptOthers == 0 then -- Others' interrupt reported?
		local IsOthersOn = "|cfcc3300fOFF|r"; print ("Others' interrupt report to self is " .. IsOthersOn);
    	else local IsOthersOn = "|cf00cc00fON|r"; print ("Others' interrupt report to self is " .. IsOthersOn);
      	end
    elseif msg == 'name' then -- Name
		if TyllusInterruptSpellName == 0 then TyllusInterruptSpellName = 1
		print ('|cf000ff96<TyllusInterrupt>|r: Announcing name of the interrupted spell is |cf00cc00fON|r');
		else TyllusInterruptSpellName = 0
			print ('|cf000ff96<TyllusInterrupt>|r: Announcing name of the interrupted spell is |cfcc3300fOFF|r');
		end
	elseif msg == 'others' then -- Others
		if TyllusInterruptOthers == 0 then TyllusInterruptOthers = 1
		print ("|cf000ff96<TyllusInterrupt>|r: Self report for Others' interrupt is |cf00cc00fON|r");
		else TyllusInterruptOthers = 0
		    print ("|cf000ff96<TyllusInterrupt>|r: Self report for Others' interrupt is |cfcc3300fOFF|r");
		end
	elseif msg == 'test' then -- Test
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "C79C6E" .. "Warrior" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Warrior
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "F58CBA" .. "Paladin" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Paladin
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "A9D271" .. "Hunter" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Hunter
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "FFF569" .. "Rogue" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Rogue
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "FFFFFF" .. "Priest" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Priest
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "C41F3B" .. "Death Knight" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Death Knight
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "0070DE" .. "Shaman" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Shaman
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "40C7EB" .. "Mage" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Mage
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "8787ED" .. "Warlock" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Warlock
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "00FF96" .. "Monk" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Monk
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "FF7D0A" .. "Druid" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Druid
		print("|cf000ff96<TyllusInterrupt>|r " .. "|cf0" .. "A330C9" .. "Demon Hunter" .. "|r" .. " interrupted " .. "\124cf071d5ff\124Hspell:304040\124h[Dummy Spell]\124h\124r") -- Demon Hunter
	else
	print ("|cf000ff96<TyllusInterrupt>|r |cf0ffff00Help|r:");
	print ("|cf0ffff00/tint setup|r >> Current setup of interrupt announces");
    print ("|cf0ffff00/tint say|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r  the interrupt announces to SAY channel");
	print ("|cf0ffff00/tint name|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r to announce the name of the interrupted spell");
	print ("|cf0ffff00/tint others|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r to report Others' interrupt to yourself");
	print ("|cf0ffff00/tint test|r >> to test out the addon");
	end
end
SlashCmdList["TINT"] = handler;